#include "local.h"



extern int gDebugFlags;



/*
==========
IPrintf

unexpected behaviour
==========
*/
int IPrintf ( char *format, ... ) {
	char input[1024];
	va_list argptr;

	va_start( argptr, format );
	vsnprintf( input, sizeof(input), format, argptr );
	va_end( argptr );

	printf( "%s %s", PREFIX_INFO, input );

	return TRUE;
}



/*
==========
DPrintf
==========
*/
int DPrintf ( int debugFlags, char *format, ... ) {
	char input[1024];
	va_list argptr;

	if ( (gDebugFlags & debugFlags) == debugFlags ) {
		va_start( argptr, format );
		vsnprintf( input, sizeof(input), format, argptr );
		va_end( argptr );

		fprintf( stderr, "%s %s", PREFIX_DEBUG, input );
	}

	return TRUE;
}



/*
==========
EPrintf
==========
*/
int EPrintf ( int die, char *format, ... ) {
	char input[1024];
	va_list argptr;
	va_start( argptr, format );
	vsnprintf( input, sizeof(input), format, argptr );
	va_end( argptr );

	fprintf( stderr, "%s %s", PREFIX_ERROR, input );

	if ( die ) {
		Quit( 1 );
	}

	return TRUE;
}



/*
==========
Quit
==========
*/
void Quit ( int returnCode ) {
	IPrintf( "exit\n\n" );

	Dispose( );
	exit( returnCode );
}



/*
==========
PrintHex
==========
*/
void PrintHex( uint8_t *data, int len ) {
	int i;

	for (i=0; i < len; i++) {
		if (!(i % 0x10)) {
			putchar( '\n' );
		}
		printf( "[0x%02X]", data[i] );
	}
	putchar( '\n' );
}



/*
==========
DebugHex
==========
*/
void DebugHex( int flags, char *caption, uint8_t *data, int len ) {
	char buffer[8];
	char output[128];
	int i;

	snprintf( output, sizeof(output), "%s (%i bytes):", caption, len );
	for (i=0; i < len; i++) {
		if (!(i % 0x10)) {
			DPrintf( flags, "%s\n", output );
			memset( output, '\0', sizeof(output) );
		}
		snprintf( buffer, sizeof(buffer), "[0x%02X]", data[i] );
		strncat( output, buffer, sizeof(output) - strlen(output) );
	}
	if ( strlen(output) ) {
		DPrintf( flags, "%s\n", output );
	}
	putchar( '\n' );
}
